var app = require('electron').app;

var preventWindowFromBeingClosed = function(window) {
  var hideInsteadofClose = function(e) {
    window.hide();
    e.preventDefault();
  };

  // Hide the window instead of closing it, so that we can bring it back
  // more quickly.
  window.on('close', hideInsteadofClose);

  app.on('before-quit', function(){
    // We need to remove our close event handler from the window,
    // otherwise the app will not quit.
    window.removeListener('close', hideInsteadofClose);
  });

  app.on('activate', function(){
    // Show the window when the customer clicks on the app icon.
    window.show();
  });
};

module.exports = preventWindowFromBeingClosed;
